import { resolveComponent as _, openBlock as r, createBlock as P, withCtx as x, createElementBlock as s, mergeProps as l, normalizeClass as f, createElementVNode as i, toHandlers as u, renderSlot as v, createCommentVNode as h, Fragment as b, renderList as y, createTextVNode as U, toDisplayString as k } from "vue";
const R = {
  emits: ["pagination-change-page"],
  props: {
    data: {
      type: Object,
      default: () => {
      }
    },
    limit: {
      type: Number,
      default: 0
    }
  },
  computed: {
    isApiResource() {
      return !!this.data.meta;
    },
    currentPage() {
      return this.isApiResource ? this.data.meta.current_page : this.data.current_page;
    },
    firstPageUrl() {
      return this.isApiResource ? this.data.links.first : null;
    },
    from() {
      return this.isApiResource ? this.data.meta.from : this.data.from;
    },
    lastPage() {
      return this.isApiResource ? this.data.meta.last_page : this.data.last_page;
    },
    lastPageUrl() {
      return this.isApiResource ? this.data.links.last : null;
    },
    nextPageUrl() {
      return this.isApiResource ? this.data.links.next : this.data.next_page_url;
    },
    perPage() {
      return this.isApiResource ? this.data.meta.per_page : this.data.per_page;
    },
    prevPageUrl() {
      return this.isApiResource ? this.data.links.prev : this.data.prev_page_url;
    },
    to() {
      return this.isApiResource ? this.data.meta.to : this.data.to;
    },
    total() {
      return this.isApiResource ? this.data.meta.total : this.data.total;
    },
    pageRange() {
      if (this.limit === -1)
        return 0;
      if (this.limit === 0)
        return this.lastPage;
      for (var t = this.currentPage, g = this.lastPage, a = this.limit, m = t - a, p = t + a + 1, c = [], o = [], e, n = 1; n <= g; n++)
        (n === 1 || n === g || n >= m && n < p) && c.push(n);
      return c.forEach(function(d) {
        e && (d - e === 2 ? o.push(e + 1) : d - e !== 1 && o.push("...")), o.push(d), e = d;
      }), o;
    }
  },
  methods: {
    previousPage() {
      this.selectPage(this.currentPage - 1);
    },
    nextPage() {
      this.selectPage(this.currentPage + 1);
    },
    selectPage(t) {
      t !== "..." && this.$emit("pagination-change-page", t);
    }
  },
  render() {
    return this.$slots.default({
      data: this.data,
      limit: this.limit,
      computed: {
        isApiResource: this.isApiResource,
        currentPage: this.currentPage,
        firstPageUrl: this.firstPageUrl,
        from: this.from,
        lastPage: this.lastPage,
        lastPageUrl: this.lastPageUrl,
        nextPageUrl: this.nextPageUrl,
        perPage: this.perPage,
        prevPageUrl: this.prevPageUrl,
        to: this.to,
        total: this.total,
        pageRange: this.pageRange
      },
      prevButtonEvents: {
        click: (t) => {
          t.preventDefault(), this.previousPage();
        }
      },
      nextButtonEvents: {
        click: (t) => {
          t.preventDefault(), this.nextPage();
        }
      },
      pageButtonEvents: (t) => ({
        click: (g) => {
          g.preventDefault(), this.selectPage(t);
        }
      })
    });
  }
}, C = (t, g) => {
  const a = t.__vccOpts || t;
  for (const [m, p] of g)
    a[m] = p;
  return a;
}, w = {
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  emits: ["pagination-change-page"],
  components: {
    RenderlessPagination: R
  },
  props: {
    data: {
      type: Object,
      default: () => {
      }
    },
    limit: {
      type: Number,
      default: 0
    },
    showDisabled: {
      type: Boolean,
      default: !1
    },
    size: {
      type: String,
      default: "default",
      validator: (t) => ["small", "default", "large"].indexOf(t) !== -1
    },
    align: {
      type: String,
      default: "left",
      validator: (t) => ["left", "center", "right"].indexOf(t) !== -1
    }
  },
  methods: {
    onPaginationChangePage(t) {
      this.$emit("pagination-change-page", t);
    }
  }
}, B = ["tabindex"], A = /* @__PURE__ */ i("span", { "aria-hidden": "true" }, "\xAB", -1), E = /* @__PURE__ */ i("span", { class: "sr-only" }, "Previous", -1), $ = {
  key: 0,
  class: "sr-only"
}, D = ["tabindex"], O = /* @__PURE__ */ i("span", { "aria-hidden": "true" }, "\xBB", -1), z = /* @__PURE__ */ i("span", { class: "sr-only" }, "Next", -1);
function N(t, g, a, m, p, c) {
  const o = _("RenderlessPagination");
  return r(), P(o, {
    data: a.data,
    limit: a.limit,
    onPaginationChangePage: c.onPaginationChangePage
  }, {
    default: x((e) => [
      e.computed.total > e.computed.perPage ? (r(), s("ul", l({ key: 0 }, t.$attrs, {
        class: ["pagination", {
          "pagination-sm": a.size == "small",
          "pagination-lg": a.size == "large",
          "justify-content-center": a.align == "center",
          "justify-content-end": a.align == "right"
        }]
      }), [
        e.computed.prevPageUrl || a.showDisabled ? (r(), s("li", {
          key: 0,
          class: f(["page-item pagination-prev-nav", { disabled: !e.computed.prevPageUrl }])
        }, [
          i("a", l({
            class: "page-link",
            href: "#",
            "aria-label": "Previous",
            tabindex: !e.computed.prevPageUrl && -1
          }, u(e.prevButtonEvents, !0)), [
            v(t.$slots, "prev-nav", {}, () => [
              A,
              E
            ])
          ], 16, B)
        ], 2)) : h("", !0),
        (r(!0), s(b, null, y(e.computed.pageRange, (n, d) => (r(), s("li", {
          class: f(["page-item pagination-page-nav", { active: n == e.computed.currentPage }]),
          key: d
        }, [
          i("a", l({
            class: "page-link",
            href: "#"
          }, u(e.pageButtonEvents(n), !0)), [
            U(k(n) + " ", 1),
            n == e.computed.currentPage ? (r(), s("span", $, "(current)")) : h("", !0)
          ], 16)
        ], 2))), 128)),
        e.computed.nextPageUrl || a.showDisabled ? (r(), s("li", {
          key: 1,
          class: f(["page-item pagination-next-nav", { disabled: !e.computed.nextPageUrl }])
        }, [
          i("a", l({
            class: "page-link",
            href: "#",
            "aria-label": "Next",
            tabindex: !e.computed.nextPageUrl && -1
          }, u(e.nextButtonEvents, !0)), [
            v(t.$slots, "next-nav", {}, () => [
              O,
              z
            ])
          ], 16, D)
        ], 2)) : h("", !0)
      ], 16)) : h("", !0)
    ]),
    _: 3
  }, 8, ["data", "limit", "onPaginationChangePage"]);
}
const Z = /* @__PURE__ */ C(w, [["render", N]]), j = {
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  emits: ["pagination-change-page"],
  components: {
    RenderlessPagination: R
  },
  props: {
    data: {
      type: Object,
      default: () => {
      }
    },
    limit: {
      type: Number,
      default: 0
    },
    showDisabled: {
      type: Boolean,
      default: !1
    },
    size: {
      type: String,
      default: "default",
      validator: (t) => ["small", "default", "large"].indexOf(t) !== -1
    },
    align: {
      type: String,
      default: "left",
      validator: (t) => ["left", "center", "right"].indexOf(t) !== -1
    }
  },
  methods: {
    onPaginationChangePage(t) {
      this.$emit("pagination-change-page", t);
    }
  }
}, S = ["tabindex"], M = /* @__PURE__ */ i("span", { "aria-hidden": "true" }, "\xAB", -1), V = ["aria-current"], L = ["tabindex"], T = /* @__PURE__ */ i("span", { "aria-hidden": "true" }, "\xBB", -1);
function F(t, g, a, m, p, c) {
  const o = _("RenderlessPagination");
  return r(), P(o, {
    data: a.data,
    limit: a.limit,
    onPaginationChangePage: c.onPaginationChangePage
  }, {
    default: x((e) => [
      e.computed.total > e.computed.perPage ? (r(), s("ul", l({ key: 0 }, t.$attrs, {
        class: ["pagination", {
          "pagination-sm": a.size == "small",
          "pagination-lg": a.size == "large",
          "justify-content-center": a.align == "center",
          "justify-content-end": a.align == "right"
        }]
      }), [
        e.computed.prevPageUrl || a.showDisabled ? (r(), s("li", {
          key: 0,
          class: f(["page-item pagination-prev-nav", { disabled: !e.computed.prevPageUrl }])
        }, [
          i("a", l({
            class: "page-link",
            href: "#",
            "aria-label": "Previous",
            tabindex: !e.computed.prevPageUrl && -1
          }, u(e.prevButtonEvents, !0)), [
            v(t.$slots, "prev-nav", {}, () => [
              M
            ])
          ], 16, S)
        ], 2)) : h("", !0),
        (r(!0), s(b, null, y(e.computed.pageRange, (n, d) => (r(), s("li", {
          class: f(["page-item pagination-page-nav", { active: n == e.computed.currentPage }]),
          key: d
        }, [
          i("a", l({
            class: "page-link",
            href: "#"
          }, u(e.pageButtonEvents(n), !0), {
            "aria-current": n == e.computed.currentPage ? "page" : null
          }), k(n), 17, V)
        ], 2))), 128)),
        e.computed.nextPageUrl || a.showDisabled ? (r(), s("li", {
          key: 1,
          class: f(["page-item pagination-next-nav", { disabled: !e.computed.nextPageUrl }])
        }, [
          i("a", l({
            class: "page-link",
            href: "#",
            "aria-label": "Next",
            tabindex: !e.computed.nextPageUrl && -1
          }, u(e.nextButtonEvents, !0)), [
            v(t.$slots, "next-nav", {}, () => [
              T
            ])
          ], 16, L)
        ], 2)) : h("", !0)
      ], 16)) : h("", !0)
    ]),
    _: 3
  }, 8, ["data", "limit", "onPaginationChangePage"]);
}
const ee = /* @__PURE__ */ C(j, [["render", F]]), H = {
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  emits: ["pagination-change-page"],
  components: {
    RenderlessPagination: R
  },
  props: {
    data: {
      type: Object,
      default: () => {
      }
    },
    limit: {
      type: Number,
      default: 0
    },
    itemClasses: {
      type: Array,
      default: () => [
        "bg-white",
        "text-gray-500",
        "border-gray-300",
        "hover:bg-gray-50"
      ]
    },
    activeClasses: {
      type: Array,
      default: () => [
        "bg-blue-50",
        "border-blue-500",
        "text-blue-600"
      ]
    }
  },
  methods: {
    onPaginationChangePage(t) {
      this.$emit("pagination-change-page", t);
    }
  }
}, q = ["disabled"], G = /* @__PURE__ */ i("span", { class: "sr-only" }, "Previous", -1), I = /* @__PURE__ */ i("svg", {
  class: "h-5 w-5",
  "aria-hidden": "true",
  xmlns: "http://www.w3.org/2000/svg",
  fill: "none",
  viewBox: "0 0 24 24",
  "stroke-width": "1.5",
  stroke: "currentColor"
}, [
  /* @__PURE__ */ i("path", {
    "stroke-linecap": "round",
    "stroke-linejoin": "round",
    d: "M15.75 19.5L8.25 12l7.5-7.5"
  })
], -1), J = ["aria-current"], K = ["disabled"], Q = /* @__PURE__ */ i("span", { class: "sr-only" }, "Next", -1), W = /* @__PURE__ */ i("svg", {
  class: "w-5 h-5",
  "aria-hidden": "true",
  xmlns: "http://www.w3.org/2000/svg",
  fill: "none",
  viewBox: "0 0 24 24",
  "stroke-width": "1.5",
  stroke: "currentColor"
}, [
  /* @__PURE__ */ i("path", {
    "stroke-linecap": "round",
    "stroke-linejoin": "round",
    d: "M8.25 4.5l7.5 7.5-7.5 7.5"
  })
], -1);
function X(t, g, a, m, p, c) {
  const o = _("RenderlessPagination");
  return r(), P(o, {
    data: a.data,
    limit: a.limit,
    onPaginationChangePage: c.onPaginationChangePage
  }, {
    default: x((e) => [
      e.computed.total > e.computed.perPage ? (r(), s("nav", l({ key: 0 }, t.$attrs, {
        class: "isolate inline-flex -space-x-px rounded-md shadow-sm",
        "aria-label": "Pagination"
      }), [
        i("button", l({
          class: ["relative inline-flex items-center rounded-l-md border px-2 py-2 text-sm font-medium focus:z-20 disabled:opacity-50", a.itemClasses],
          disabled: !e.computed.prevPageUrl
        }, u(e.prevButtonEvents, !0)), [
          v(t.$slots, "prev-nav", {}, () => [
            G,
            I
          ])
        ], 16, q),
        (r(!0), s(b, null, y(e.computed.pageRange, (n, d) => (r(), s("button", l({
          class: ["relative inline-flex items-center border px-4 py-2 text-sm font-medium focus:z-20", [
            n == e.computed.currentPage ? a.activeClasses : a.itemClasses,
            n == e.computed.currentPage ? "z-30" : ""
          ]],
          "aria-current": e.computed.currentPage ? "page" : null,
          key: d
        }, u(e.pageButtonEvents(n), !0)), k(n), 17, J))), 128)),
        i("button", l({
          class: ["relative inline-flex items-center rounded-r-md border px-2 py-2 text-sm font-medium focus:z-20 disabled:opacity-50", a.itemClasses],
          disabled: !e.computed.nextPageUrl
        }, u(e.nextButtonEvents, !0)), [
          v(t.$slots, "next-nav", {}, () => [
            Q,
            W
          ])
        ], 16, K)
      ], 16)) : h("", !0)
    ]),
    _: 3
  }, 8, ["data", "limit", "onPaginationChangePage"]);
}
const te = /* @__PURE__ */ C(H, [["render", X]]);
export {
  Z as Bootstrap4Pagination,
  ee as Bootstrap5Pagination,
  R as RenderlessPagination,
  te as TailwindPagination
};
